﻿#region About
// Course material: C# for numerical methods
// Copyright (c) 2009-2010, Igor Grešovnik
#endregion About


using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using NumLib.Classes;


// Preprosta konzolna aplikacija, ki prebere parametre in nekaj izračuna:

namespace test_console
{
    class Program
    {


        static void Main(string[] args)
        {
            // TestConsoleApplication();

            // Complex.Example();  // Example with complec numbers

            //ComplexVector.Example();

            // Matrix.Example();

            SparseMatrix.Example();

        }

        static void TestConsoleApplication()
        {
            try
            {
                int n;
                double x, val;
                string str;
                Console.WriteLine();
                Console.Write("Argument funkcije: ");
                str = Console.ReadLine();
                x = double.Parse(str);
                Console.Write("potenca: ");
                str = Console.ReadLine();
                n = int.Parse(str);
                Console.WriteLine();
                // Izračun vrednosti nekaterih funkcij in izpis rezultatov:
                val = Pow.Square(x);
                Console.WriteLine("Kvadrat " + x.ToString() + ": " + val.ToString());
                Console.WriteLine();
                val = Pow.Cubic(x);
                Console.WriteLine("Kub " + x.ToString() + ": " + val.ToString());
                Console.WriteLine();
                val = Pow.Power(x,n);
                Console.WriteLine("Potenca " + x.ToString() + " na " + n.ToString() + ": " + val.ToString());
                // Console.WriteLine("Potenca " + x + " na " + n + ": " + val);
            }
            catch (Exception ex)
            {
                // Tu lovimo napake. Poskusi za argument funkcije vstaviti neštevilčno vrednost,
                // da se bo izvedel ta blok!
                Console.WriteLine();
                Console.WriteLine("Prišlo je do napake. Opis: " + ex.Message);
                Console.WriteLine();
            }
            finally
            {
                // Ta blok se izvede v vsakem primeru, tudi, če pride do napake.
                // Izvajanje programa se v primeru napake prekine in se nadaljuje v prvem
                // catch (...) {...} bloku za mestom napake.
                Console.WriteLine();
                Console.WriteLine("Izvajanje programa je končano.");
            }
        } // Main

    }
}
